/* noss.c     nos supervisor

   integrate with Sx   13 Aug 2006
 */

#include "sx.h"

extern int clock;		// sxm.c
extern int CP, DP;		// load.c
extern int status;		// sx.c
extern int userp;

int sclock = 0, uclock = 0, ustart;	// system, user, clock
int n_switch = 0;

PRIVATE void outa(int op, int arg){
	M[CP] = (arg << 8) | op;
	CP++;
}

PRIVATE void dotime(void){
	sclock += clock;
	uclock += (clock - ustart);
}

void boot(void){
	int callswitchp;
	int a_activep, a_status, a_switchp;

	a_activep = searchsym("activep");
	a_status = searchsym("status");
	a_switchp = searchsym("switchp");
	callswitchp = CP;
	outa(icCall,a_switchp);
	outa(icEnd,0);

	eval(1);       // boot nos
	dotime();

	// userp is set by restoreCstate called from "runnable"
	while(M[a_activep] != 0){	// interrupt-execute loop
		M[a_status] = status;	// update to nos
		printf(" * ");
		n_switch++;
		eval(callswitchp);		// run switcher
		dotime();
	}
}

void report(void){
	printf("\n%d inst. %d cycles system %d user %d switchp %d\n",
		ninst, sclock, sclock-uclock, uclock, n_switch);
}

int main(int argc, char *argv[]){
  if( argc < 2 ) {
	printf("usage : noss objfile\n");
	exit(0);
  }
  loadobj(argv[1]);
  initchip();
  boot();
  report();
  return 0;
}

